/*
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2002 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.util.zip.*;

public class BCLogBrowserController extends NSWindowController
{
    static BCLogBrowserController _sharedInstance = null;
    
    static String user = NSPathUtilities.stringByExpandingTildeInPath("~");
    
    //static String[] long_month_names = {"January","February","March","April","May","June","July","August","September","October","November","December"};
    static String[] short_month_names = {"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
    
    static String valid_uri_special_chars = ".+%&#~?_/-=";
    
    NSBrowser browse_days;
    NSButton btn_replay;
    NSButton btn_vote;
    NSButton btn_agree;
    NSButton btn_copyurl;
    NSButton btn_jumptourl;
    NSTextField fld_day;
    NSTableView table_scripts;
    
    BCLogBrowserListViewDataSource listDataSource;
    
    static BCLogBrowserController sharedLogBrowser()
    {
        if (_sharedInstance == null)
        {
            _sharedInstance = new BCLogBrowserController();
        }
        
        return _sharedInstance;
    }
    
    private BCLogBrowserController()
    {
        super("LogWindow");
        loadWindow();
        
		window().setFrameUsingName("logwindow_frame");
        window().setFrameAutosaveName("logwindow_frame");
        table_scripts.setAutosaveName("logwindow_table_revision_1");
		table_scripts.setAutosaveTableColumns(true);
        browse_days.setTakesTitleFromPreviousColumn(false);
        
        listDataSource = new BCLogBrowserListViewDataSource();
        table_scripts.setDataSource(listDataSource);
        
        //browse_days.setAcceptsArrowKeys(true);
        browserSelectionHasChanged(null);
        
        buttons_validate();
    }
    
    public String browserPath()
    {
        return browse_days.path();
    }
    
    public void reloadTable()
    {
        table_scripts.reloadData();
        table_scripts.scrollRowToVisible(table_scripts.numberOfRows() - 1);
		table_scripts.display();
    }
    
    public void reloadTableIfShowing(int year,int month,int day)
    {
		// ̃Xgɕ\Ă̂w肳ꂽtƓ烊[hB
		String path = browse_days.path();
		try
		{
			int current_year = Integer.parseInt(path.substring(1,5));
			int current_month = Integer.parseInt(path.substring(6,8));
			int current_day = Integer.parseInt(path.substring(9,11));
			if (year == current_year && month == current_month && day == current_day)
			{
				// change toveta 2002.09.16
                // deselectAllĂȂƃ[hɃNAہAƂǂO
                NSEnumerator enu;
                Vector rows = new Vector();
                Number row;
                // Enumerator̒gtable𑀍삵Ă܂ƕۏ؂Ȃ?̂Vectorɑޔ
                enu = table_scripts.selectedRowEnumerator();
                row = (Number)enu.nextElement();
                while(row != null){
                    rows.add(row);
                    row = (Number)enu.nextElement();
                }
                table_scripts.deselectAll(this);
				browserSelectionHasChanged(null);
                for(int i=0,size=rows.size(); i < size; i++){
                    row = (Number)rows.elementAt(i);
                    table_scripts.selectRow(row.intValue(),true);
                }
			}
		}
		catch (Exception e) {
			//BCFoundation.todaysLogFileUnlock();
		}
    }
    
    // Actions
    public void browserSelectionHasChanged(Object sender)
    {
        // IĂ̂dayicolumn 2jȂ牺̃Xgɒg\B
        if (browse_days.selectedColumn() == 2)
        {
            String path = browse_days.path();
            String year = path.substring(1,5);
            String month = path.substring(6,8);
            String day = path.substring(9,11);
            String month_str;
            try{ month_str = short_month_names[ Integer.parseInt(month) - 1 ]; }catch(Exception e){ month_str = month; }
            String mdy = month_str+'/'+day+'/'+year;
            fld_day.setStringValue(mdy);
            
			/*try
			{
				File gzipped = new File(user,"Library/BotCli/log"+browse_days.path()+".log.gz");
				if (gzipped.exists())
				{
					BCLogDataServer.sharedLogServer().loadTableContents(new GZIPInputStream(new FileInputStream(gzipped)));
				}
				else
				{
					File log = new File(user,"Library/BotCli/log"+browse_days.path()+".log");
					BCLogDataServer.sharedLogServer().loadTableContents(new FileInputStream(log));
				}
			}
			catch (Exception e) {}*/
			try {
				BCLogDataServer.sharedLogServer().hold(
										Integer.parseInt(year),
										Integer.parseInt(month),
										Integer.parseInt(day));
			}
			catch (NumberFormatException e) {}
        }
        else
        {
            fld_day.setStringValue("");
            
            //BCLogDataServer.sharedLogServer().beEmpty();
			BCLogDataServer.sharedLogServer().unhold();
        }
        table_scripts.reloadData();
		table_scripts.display();
    }
    
    public void replay(Object sender)
    {
        BCLogData log = BCLogDataServer.sharedLogServer().getHolded();
		if (log == null) return;
        
        int n_rows = table_scripts.numberOfRows();
        for (int i = 0;i < n_rows;i++)
        {
            if (!table_scripts.isRowSelected(i)) continue;
            
            Hashtable info = log.elementAt(i);
            replay_bottle(info);
        }
    }
	
	public static void replay_bottle(Hashtable bottle)
	{
		String app_name = NSBundle.mainBundle().localizedStringForKey("CFBundleShortVersionString","BotCli","InfoPlist");
		String ch = (String)bottle.get("channel"); if (ch == null) ch = "";
		String script = (String)bottle.get("script"); if (script == null) script = "";
		String ghost = (String)bottle.get("ghost");
		String ifghost = (String)bottle.get("ifghost");
		
		Vector req = new Vector();
		req.add("SEND SSTP/1.4");
		req.add("Sender: "+app_name+" replaying; ["+ch+(ifghost == null ? "]" : "][Target:"+ifghost+"]"));
		if (ifghost != null) req.add("IfGhost: "+ifghost);
		else if (ghost != null) req.add("IfGhost: "+ghost);
		req.add("Script: "+BCScriptAnalyzer.expandYenURL(script));
	
		BCFoundation.sharedFoundation().getQueue().push(req);
	}
    
    public void vote(Object sender)
    {
		BCLogData log = BCLogDataServer.sharedLogServer().getHolded();
        if (log == null) return;
	
		if (BCFoundation.sharedFoundation().slpp_connected())
		{
			if (table_scripts.numberOfSelectedRows() == 1)
			{
				Hashtable info = log.elementAt(table_scripts.selectedRow());
				if (info.get("type") != null && ((String)info.get("type")).equals("OB"))
				{
					BCFoundation.sharedFoundation().getSlppConnection().vote((String)info.get("mid"),"Vote");
				}
			}
		}
    }
    
    public void agree(Object sender)
    {
		BCLogData log = BCLogDataServer.sharedLogServer().getHolded();
        if (log == null) return;
	
		if (BCFoundation.sharedFoundation().slpp_connected())
		{
			if (table_scripts.numberOfSelectedRows() == 1)
			{
				Hashtable info = log.elementAt(table_scripts.selectedRow());
				if (info.get("type") != null && ((String)info.get("type")).equals("OB"))
				{
					BCFoundation.sharedFoundation().getSlppConnection().vote((String)info.get("mid"),"Agree");
				}
			}
		}
    }
    
    public void copy_url(Object sender)
    {
		// WFly[Xg{[hɃZbg
		String url_string = getURLFromSelectedBottle();
		if (url_string == null) return;
		
		NSPasteboard gen_p = NSPasteboard.generalPasteboard();
		NSMutableArray types = new NSMutableArray();
		types.addObject(NSPasteboard.StringPboardType);
		gen_p.declareTypes(types,null);
		gen_p.setStringForType(url_string,NSPasteboard.StringPboardType);
    }
    
    public void jump_to_url(Object sender)
    {
		// OSoRŃuEUɂURLJ
		String url_string = getURLFromSelectedBottle();
		if (url_string == null) return;
		
		try
		{
			NSWorkspace.sharedWorkspace().openURL(new URL(url_string));
		}
		catch (Exception e){}
    }
    
    public String getURLFromSelectedBottle()
    {
		// oȂnullԂB
		
		BCLogData log = BCLogDataServer.sharedLogServer().getHolded();
		if (log == null) return null;
		
		if (table_scripts.numberOfSelectedRows() == 1)
		{
			Hashtable info = log.elementAt(table_scripts.selectedRow());
			if (info.get("script") != null)
			{
				String script = (String)info.get("script");
				
				// http://TB
				int blockstart = script.indexOf("http://");
				if (blockstart == -1) return null;
				
				// At@xbgAAvalid_uri_special_charsȊO̕ɏoA܂͕񂪏I܂ł͈̔͂
				// URLubNƂB
				int blockend = blockstart + 7;
				int len = script.length();
				while (blockend < len)
				{
					char current = script.charAt(blockend);
					if ((current >= 'A' && current <= 'Z') || 
						(current >= 'a' && current <= 'z') ||
						Character.isDigit(current) ||
						valid_uri_special_chars.indexOf(current) != -1)
					{
						blockend++;
					}
					else
					{
						break;
					}
				}
				if (blockstart == blockend) return null; // http://̌ɑĂȂ
				String url_string = script.substring(blockstart,blockend);
				
				return url_string;
			}
		}
		
		return null;
    }
    
    // Delegete of NSBrowser
    public int browserNumberOfRowsInColumn(NSBrowser sender,int column)
    {
        File parentdir = new File(user,"Library/BotCli/log"+browse_days.pathToColumn(column));
        if (!parentdir.exists()) return 0;
        
        // 擪̃t@C.DS_StorefNgB
        File[] files = parentdir.listFiles();
        int n_valid_files = files.length;
        if (files[0].getName().charAt(0) == '.') n_valid_files--;
        
        return n_valid_files;
    }
    
    public void browserWillDisplayCell(NSBrowser sender,Object cell,int row,int column)
    {
        NSBrowserCell bcell = (NSBrowserCell)cell;
        
        File parentdir = new File(user,"Library/BotCli/log"+browse_days.pathToColumn(column));
        if (!parentdir.exists()) return;
        
        File[] files = parentdir.listFiles();
        if (files[0].getName().charAt(0) == '.') row++; // .DS_StoreXLbv
        
		String fname = files[row].getName();
		int period_pos = fname.indexOf('.');
	
        bcell.setStringValue(period_pos == -1 ? fname : fname.substring(0,period_pos));
        bcell.setLeaf(!files[row].isDirectory());
    }
    
    public String browserTitleOfColumn(NSBrowser sender,int column)
    {
        switch (column)
        {
            case 0: return "Year";
            case 1: return "Month";
            case 2: return "Day";
            default: return "";
        }
    }
    
    public void buttons_validate()
	{
		btn_replay.setEnabled(table_scripts.numberOfSelectedRows() > 0);
		
		BCLogData log = BCLogDataServer.sharedLogServer().getHolded();
        if (log == null) return;
	
		// Vote{^Agree{^
		boolean votebutton_enable = false;
		if (BCFoundation.sharedFoundation().slpp_connected())
		{
			if (table_scripts.numberOfSelectedRows() == 1)
			{
				Hashtable info = log.elementAt(table_scripts.selectedRow());
				if (info.get("type") != null && ((String)info.get("type")).equals("OB"))
				{
					votebutton_enable = true;
				}
			}
		}
		btn_vote.setEnabled(votebutton_enable);
		btn_agree.setEnabled(votebutton_enable);
	
		// Copy URL,Jump to URL{^
		boolean urlbutton_enable = false;
		if (table_scripts.numberOfSelectedRows() == 1)
		{
			Hashtable info = log.elementAt(table_scripts.selectedRow());
			if (info.get("script") != null)
			{
				String script = (String)info.get("script");
				
				urlbutton_enable = (script.indexOf("http://") != -1);
			}
		}
		btn_copyurl.setEnabled(urlbutton_enable);
		btn_jumptourl.setEnabled(urlbutton_enable);
    }
    
    // Delegete of NSTableView
    public void tableViewSelectionDidChange(NSNotification notification)
    {
        // notification͖
        buttons_validate();
    }
}
