/*
	$Id: BCLogBrowserListViewDataSource.java,v 1.3 2003/02/11 06:43:48 admin Exp $
	-----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2002 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class BCLogBrowserListViewDataSource implements NSTableView.DataSource
{
    // implementaion of NSTableView.DataSource
    public int numberOfRowsInTableView(NSTableView aTableView)
    {
        BCLogData holded = BCLogDataServer.sharedLogServer().getHolded();
        
        if (holded == null) return 0;
        return holded.size();
    }
    
    public boolean tableViewAcceptDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation)
    {
        // optional
        return false;
    }
    
    public Object tableViewObjectValueForLocation(
        NSTableView aTableView,
        NSTableColumn aTableColumn,
        int rowIndex)
    {
        BCLogData holded = BCLogDataServer.sharedLogServer().getHolded();
		if (holded == null || rowIndex >= holded.size()) return "";
		
        Hashtable info = holded.elementAt(rowIndex);
        String column = (String)aTableColumn.identifier();
        //String result;
        
        //result = (String)info.get(column);
        //if (result == null) result = "";
        
        if (column.equals("type"))
        {
			String result = (String)info.get("type");
            if (result.equals("UB"))
            {
                NSMutableAttributedString mas = new NSMutableAttributedString(result);
                mas.addAttributeInRange(
                    NSAttributedString.ForegroundColorAttributeName,
                    NSColor.redColor(),
                    new NSRange(0,result.length())
                    );
                return mas;
            }
            else if (result.equals("OU"))
            {
                NSMutableAttributedString mas = new NSMutableAttributedString(result);
                mas.addAttributeInRange(
                    NSAttributedString.ForegroundColorAttributeName,
                    NSColor.greenColor(),
                    new NSRange(0,result.length())
                    );
                return mas;
            }
			else if (result.equals("FB"))
            {
                NSMutableAttributedString mas = new NSMutableAttributedString(result);
                mas.addAttributeInRange(
                    NSAttributedString.ForegroundColorAttributeName,
                    NSColor.blueColor(),
                    new NSRange(0,result.length())
                    );
                return mas;
            }
			else
			{
				return result;
			}
        }
        else if (column.equals("message"))
        {
			String type = (String)info.get("type");
			if (!type.equals("FB")) // script̂݁B
			{
				String script = (String)info.get("script");
				NSMutableAttributedString attributed_script = (NSMutableAttributedString)info.get("temporary-attributed-script");
				
				if (attributed_script == null) // ܂AttributedłĂȂ
				{
					attributed_script = new NSMutableAttributedString(script);
					BCScriptAnalyzer.analyze(attributed_script);
					
					info.put("temporary-attributed-script",attributed_script); // LbV
				}
				return attributed_script;
			}
			else // scriptfbmsgǂ炩͗B
			{
				String script = (String)info.get("script");
				String fbmsg = (String)info.get("fbmsg");
				NSMutableAttributedString attributed_script = (NSMutableAttributedString)info.get("temporary-attributed-script");
				NSMutableAttributedString attributed_fbmsg = null;
				
				if (script != null)
				{
					if (attributed_script == null) // ܂AttributedłĂȂ
					{
						attributed_script = new NSMutableAttributedString(script);
						BCScriptAnalyzer.analyze(attributed_script);
						
						info.put("temporary-attributed-script",attributed_script); // LbV
					}
				}
				if (fbmsg != null)
				{
					attributed_fbmsg = new NSMutableAttributedString(fbmsg);
					attributed_fbmsg.addAttributeInRange(
							NSAttributedString.ForegroundColorAttributeName,
							NSColor.blueColor(),
							new NSRange(0,fbmsg.length())
						);
				}
		
				if (script == null && fbmsg != null)
				{
					return attributed_fbmsg;
				}
				else if (script != null && fbmsg == null)
				{
					return attributed_script;
				}
				else if (script != null && fbmsg != null)
				{
					// A
					attributed_fbmsg.appendAttributedString(new NSAttributedString(" ### "));
					attributed_fbmsg.appendAttributedString(attributed_script);
					return attributed_fbmsg;
				}
				else
				{
					return null;
				}
			}
        }
		else if (column.equals("ghost"))
		{
			// ifghostΐԎifghostB
			// ΍ghostB
			String ifghost = (String)info.get("ifghost");
			if (ifghost != null)
			{
				NSMutableAttributedString mas = new NSMutableAttributedString(ifghost);
				mas.addAttributeInRange(
						NSAttributedString.ForegroundColorAttributeName,
						NSColor.redColor(),
						new NSRange(0,ifghost.length())
					);
				return mas;
			}
	    
			return (String)info.get("ghost");
		}
		else if (column.equals("v&a"))
		{
			// `F
			// ${agree}/${vote}
			String vote = (String)info.get("vote");
			String agree = (String)info.get("agree");
			if (vote == null && agree == null)
			{
				// ǂ݂Ȃ΋
				return null;
			}
			else
			{
				return (agree == null ? "0" : agree) + "/" + (vote == null ? "0" : vote);
			}
		}
		else if (column.equals("time"))
		{
			String data = (String)info.get("time");
			return data.substring(0,2)+':'+data.substring(2,4)+':'+data.substring(4);
		}
		else
		{
			// channel͂̂܂܁B
			return info.get(column);
		}
    }
    
    public void tableViewSetObjectValueForLocation(
        NSTableView aTableView,
        Object anObject,
        NSTableColumn aTableColumn,
        int rowIndex)
    {
        // do nothing
    }
    
    public int tableViewValidateDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation)
    {
        // optional
        return 0;
    }
    
    public boolean tableViewWriteRowsToPasteboard(
        NSTableView tableView,
        NSArray rows,
        NSPasteboard pboard)
    {
        // optional
        return false;
    }
}
