/*
	$Id: BCLogDataServer.java,v 1.5 2003/02/11 06:43:48 admin Exp $
	-----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2002 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import java.io.*;
import java.util.*;
import java.util.zip.*;
import java.net.*;

public class BCLogDataServer extends Thread
{
    protected static BCLogDataServer _sharedInstance = null;
    public static String home = NSPathUtilities.stringByExpandingTildeInPath("~");
	public static final int CACHE_SIZE = 7;
	public static final int AUTO_COMMIT_INTERVAL = 20 * 1000; // 20bɎcommit
    
	BCLogData holded = null; // cacheƈႢAǂo鎖́B
    Vector cache; // <BCLogData>
    
    public static BCLogDataServer sharedLogServer()
    {
        if (_sharedInstance == null)
        {
            _sharedInstance = new BCLogDataServer();
			_sharedInstance.start();
        }
        return _sharedInstance;
    }
    
    protected BCLogDataServer()
    {
        cache = new Vector();
    }
	
	public void run() {
		while (true) {
			try {
				sleep(AUTO_COMMIT_INTERVAL);
			} catch (Exception e) {}
			
			commitAll();
		}
	}
	
	public BCLogData hold(int year,int month,int day) {
		unhold();
		holded = get(year,month,day);
		return holded;
	}
	
	public void unhold() {
		if (holded != null) {
			holded.commit();
		}
		holded = null;
	}
	
	public BCLogData getHolded() {
		return holded;
	}
	
	public BCLogData get(int year,int month,int day) {
		// holdĂAԂB
		if (holded != null &&
			holded.getYear() == year &&
			holded.getMonth() == month &&
			holded.getDay() == day) {
			
			return holded;
		}
		
		// cacheɓĂAԂB
		for (Enumeration e = cache.elements(); e.hasMoreElements(); ) {
			BCLogData log = (BCLogData)e.nextElement();
			if (log.getYear() == year &&
				log.getMonth() == month &&
				log.getDay() == day) {
				
				return log;
			}
		}
		
		// ĂȂB
		BCLogData new_log = new BCLogData(year,month,day);
		cacheThis(new_log);
		return new_log;
	}
    
    protected void cacheThis(BCLogData log)
	{
		// cacheɓĂA擪ɈړB
		// ĂȂ΁ALbVtȂŌ̍ڂĐ擪ɒǉB
		int cached_pos = cache.indexOf(log);
		if (cached_pos == -1) {
			if (cache.size() >= CACHE_SIZE) {
				// OcommitB
				BCLogData last = (BCLogData)cache.elementAt(cache.size()-1);
				last.commit();
				cache.remove(cache.size()-1);
			}
		}
		else {
			cache.remove(cached_pos);
		}
		cache.add(0,log);
	}
	
	public void commitAll()
	{
		// LbVĂSẴOcommitB
		if (holded != null) {
			holded.commit();
		}
		
		for (Enumeration e = cache.elements(); e.hasMoreElements(); ) {
			BCLogData log = (BCLogData)e.nextElement();
			log.commit();
		}
	}
	
    public void broadcastLog(String script,String channel,String mid,String uid,String ghost,String ifghost)
    {
        submit("OB",script,channel,null,mid,uid,ghost,ifghost);
    }
    
    public void sendBroadcastLog(String script,String channel,String ghost,String ifghost)
    {
        submit("UB",script,channel,null,null,null,ghost,ifghost);
    }
    
    public void unicastLog(String script,String uid)
    {
        submit("OU",script,null,null,null,uid,null,null);
    }
    
    public void forceBroadcastLog(String script,String mid,String uid,String message)
    {
		submit("FB",script,null,message,mid,uid,null,null);
    }
    
    private void submit(String type,String script,String channel,String fbmsg,String mid,String uid,String ghost,String ifghost)
    {
        // ̓t擾āÃt@C
        // p[^́Anull̕͏ȗꂽ̂ƌȂB
        // GR[h͂ȂœnĂB
		Calendar cal = Calendar.getInstance();
		int year = cal.get(Calendar.YEAR);
		int month = cal.get(Calendar.MONTH) + 1;
		int day = cal.get(Calendar.DAY_OF_MONTH);
		int hour = cal.get(Calendar.HOUR);
		int minute = cal.get(Calendar.MINUTE);
		int second = cal.get(Calendar.SECOND);
		
		// ̃O擾
		BCLogData log_of_today = get(year,month,day);
                
        /*
            logt@Č`F
            type:[^Cv],script:[XNvg],...
            ̂悤ɁAx:f[^,x:f[^,...ƂԂŏd˂ĂAf[^ɂĈsƂȂB
            ΕKvtB[h͏ȗėǂAOt@Č`ςĂΉłB
            
            
            xF
            type: UB / OB / UU / OU / FB ̂ǂꂩBꂼAUser Broadcasted / Others Broadcasted / User Unicasted / Others Unicasted / ForceBroadcastedB̃vgRłunicastłł悤ɂȂ肻B
            script: ShiftJIS + www-form-url-encodedŃGR[hꂽSakuraScript
            channel: scriptƓGR[hŃ`l
            mid: GR[hKvȂ悤AÔwww-form-url-encodedłMID
            date: MMDDYYYY l
            time: HHMMSS 24ԕ\L
            fbmsg: scriptƓGR[hForceBroadcast̃_CAObZ[W
            uid: GR[hKvȂ悤AÔwww-form-url-encodedłUID
            ghost: scriptƓGR[hŃS[Xg
			ifghost: scriptƓGR[hIfGhostiMłGhostj̎w
			vote: l
			agree: l
        */
        Hashtable bottle = new Hashtable();
		if (type != null) {
			bottle.put("type",type);
		}
		if (script != null) {
			bottle.put("script",script);
		}
		if (channel != null) {
			bottle.put("channel",channel);
		}
		if (mid != null) {
			bottle.put("mid",mid);
		}
		bottle.put("date",(month <= 9 ? "0"+month : ""+month) + (day <= 9 ? "0"+day : ""+day) + year);
		bottle.put("time",(hour <= 9 ? "0"+hour : ""+hour) + (minute <= 9 ? "0"+minute : ""+minute) + (second <= 9 ? "0"+second : ""+second));
		if (fbmsg != null) {
			bottle.put("fbmsg",fbmsg);
		}
		if (uid != null) {
			bottle.put("uid",uid);
		}
		if (ghost != null) {
			bottle.put("ghost",ghost);
		}
		if (ifghost != null) {
			bottle.put("ifghost",ifghost);
		}
		
		// ǉ
		log_of_today.add(bottle);
		
		// uEUŕ\̃t@Ĉ̂A[hB
        String pathOfBrowser = "/"+year+"/"+(month <= 9 ? "0"+month : ""+month)+"/"+(day <= 9 ? "0"+day : ""+day);
        BCLogBrowserController logBrowser = BCLogBrowserController.sharedLogBrowser();
        if (logBrowser.browserPath().equals(pathOfBrowser))
        {
            logBrowser.reloadTable();
        }
    }
    
	public static Vector logged_years()
	{
		// ߂l: Vector<String>
		Vector result = new Vector();
		
		File parentdir = new File(home,"Library/BotCli/log");
        if (!parentdir.exists()) {
			return result;
		}
        
        File[] files = parentdir.listFiles();
		for (int i = 0; i < files.length; i++) {
			File f = files[i];
			
			if (!f.isDirectory() ||
				f.getName().charAt(0) == '.') {
				continue;
			}
			
			result.add(f.getName());
		}
		
		return result;
	}
	
	public static Vector logged_months(String year)
	{
		// ߂l: Vector<String>
		Vector result = new Vector();
		
		File parentdir = new File(home,"Library/BotCli/log/"+year);
        if (!parentdir.exists()) {
			return result;
		}
        
        File[] files = parentdir.listFiles();
		for (int i = 0; i < files.length; i++) {
			File f = files[i];
			
			if (!f.isDirectory() ||
				f.getName().charAt(0) == '.') {
				continue;
			}
			
			result.add(f.getName());
		}
		
		return result;
	}
	
	public static Vector logged_days(String year,String month)
	{
		// ߂l: Vector<String>
		Vector result = new Vector();
		
		File parentdir = new File(home,"Library/BotCli/log/"+year+"/"+month);
        if (!parentdir.exists()) {
			return result;
		}
        
        File[] files = parentdir.listFiles();
		for (int i = 0; i < files.length; i++) {
			File f = files[i];
			
			int period_pos = f.getName().indexOf('.');
			if (!f.isFile() ||
				f.getName().charAt(0) == '.' ||
				period_pos == -1) {
				
				continue;
			}
			
			result.add(f.getName().substring(0,period_pos));
		}
		
		return result;
	}
}
