/*
	$Id: BCLogModifier.java,v 1.5 2003/02/11 06:43:48 admin Exp $
	-----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2002 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.util.*;
import java.util.zip.*;

public class BCLogModifier extends Thread
{
    /*private static int interval = 5000; // 5bɃL[(ͥ)!
    
    Vector queue; // content : (ModifyCommand)R}h
    volatile boolean flag_term = false;
    
    public BCLogModifier()
    {
		queue = new Vector();
    }
    
    public void run()
    {
		Vector work_vec = new Vector(); // ƗpB
		
		while (!flag_term)
		{
			try
			{
				sleep(interval);
			}
			catch (InterruptedException e) {}
			
			if (queue.size() > 0)
			{
				synchronized(queue)
				{
					// R}hsɃL[Ƀf[^荞܂̂hB
					work_vec.clear();
					work_vec.addAll(queue);
					queue.clear();
				}
		
				while (!BCFoundation.todaysLogFileTryLock()) {}
				
				Vector filewrite_queue = new Vector();
				final int n_commands = work_vec.size();
				for (int i = 0;i < n_commands;i++)
				{
					ModifyCommand command = (ModifyCommand)work_vec.elementAt(i);
					if (command.getType().equals("Vote") || command.getType().equals("Agree"))
					{
						Object[] argv = command.getArgv();
						String mid = (String)argv[0];
						int num = ((Integer)argv[1]).intValue();
						
						Calendar timestamp = BCMidAnalyzer.analyzeTimeStampFromMid(mid);
						int year = timestamp.get(Calendar.YEAR);
						int month = timestamp.get(Calendar.MONTH) + 1;
						int day = timestamp.get(Calendar.DAY_OF_MONTH);
						
						modifyVoteOrAgreeInLog(filewrite_queue,year,month,day,mid,num,command.getType());
						
						// Y郍O܂ɃOuEUJĂXVB
						BCLogBrowserController.sharedLogBrowser().reloadTableIfShowing(year,month,day);
					}
				}
				execute_filewrite(filewrite_queue);
		
				// bN
				BCFoundation.todaysLogFileUnlock();
			}
		}
    }
    
    protected void modifyVoteOrAgreeInLog(Vector filewrite_queue,int year,int month,int day,String mid,int num,String type)
    {
		// filewrite_queue̒ɍ̃Ot@C܂܂Ă΂ɒǉB
		BCLogData log = null;
		boolean have_to_reqister_to_queue = false;
		final int queuesize = filewrite_queue.size();
		for (int i = 0;i < queuesize;i++)
		{
			FileWriteQueueElem elem = (FileWriteQueueElem)filewrite_queue.elementAt(i);
			if (elem.getYear() == year && elem.getMonth() == month && elem.getDay() == day)
			{
				log = elem.getLogData();
				break;
			}
		}
		
		boolean compressed = false;
		if (log == null) // ܂JĂȂ
		{
			// Yt@CJB
			File logfile = new File(
					BCLogDataServer.home,
					"Library/BotCli/log/"+year+"/"+(month<=9?"0"+month:""+month)+"/"+(day<=9?"0"+day:""+day)+".log");
			if (!logfile.exists())
			{
				logfile = new File(
					BCLogDataServer.home,
					"Library/BotCli/log/"+year+"/"+(month<=9?"0"+month:""+month)+"/"+(day<=9?"0"+day:""+day)+".log.gz");
				compressed = true;
			}
			if (!logfile.exists()) {
				return;
			}
			
			if (compressed) {
				try {
					log = new BCLogData(new GZIPInputStream(new FileInputStream(logfile)));
				}
				catch(Exception e) {
					return;
				}
			}
			else {
				log = new BCLogData(logfile);
			}
			have_to_reqister_to_queue = true;
		}
	
		// YMID{gB
		boolean found = false;
		Vector records = log.getArrayOfRecords();
		final int size_records = records.size();
		for (int i = 0;i < size_records;i++)
		{
			Hashtable record = (Hashtable)records.elementAt(i);
			String mid_in_record = (String)record.get("mid");
			if (mid_in_record != null && mid_in_record.equals(mid))
			{
				// B
				if (type.equals("Vote"))
				{
					record.put("vote",Integer.toString(num));
				}
				else
				{
					record.put("agree",Integer.toString(num));
				}
				
				found = true;
				break;
			}
		}
		
		if (found && have_to_reqister_to_queue)
		{
			filewrite_queue.add(new FileWriteQueueElem(year,month,day,log,compressed));
		}
    }
    
    protected void execute_filewrite(Vector queue)
    {
		final int n_elems = queue.size();
		for (int i = 0;i < n_elems;i++)
		{
			FileWriteQueueElem elem = (FileWriteQueueElem)queue.elementAt(i);
			int year = elem.getYear();
			int month = elem.getMonth();
			int day = elem.getDay();
			BCLogData logdata = elem.getLogData();
			boolean haveToCompress = elem.getCompress();
			
			File logfile = new File(
				BCLogDataServer.home,
				"Library/BotCli/log/"+year+"/"+(month<=9?"0"+month:""+month)+"/"+(day<=9?"0"+day:""+day)+".log"+(haveToCompress?".gz":""));
			try
			{
				if (haveToCompress)
				{
					logdata.save(new GZIPOutputStream(new FileOutputStream(logfile)));
				}
				else
				{
					logdata.save(new FileOutputStream(logfile));
				}
			} catch (Exception e) {e.printStackTrace();}
		}
    }
    
    public void terminate()
    {
		flag_term = true;
		interrupt();
		while (isAlive()) {}
    }
    
    public void updateVoteNumOfBottle(String mid,int num)
    {
		queue.add( new ModifyCommand("Vote",new Object[] { mid , new Integer(num) }) );
    }
    
    public void updateAgreeNumOfBottle(String mid,int num)
    {
		queue.add( new ModifyCommand("Agree",new Object[] { mid , new Integer(num) }) );
    }*/
	
	public static void updateVoteNumOfBottle(String mid,int num)
	{
		updateVoteOrAgree("vote",mid,num);
	}
	
	public static void updateAgreeNumOfBottle(String mid,int num)
	{
		updateVoteOrAgree("agree",mid,num);
	}
    
	protected static void updateVoteOrAgree(String type,String mid,int num)
	{
		Calendar timestamp = BCMidAnalyzer.analyzeTimeStampFromMid(mid);
		int year = timestamp.get(Calendar.YEAR);
		int month = timestamp.get(Calendar.MONTH) + 1;
		int day = timestamp.get(Calendar.DAY_OF_MONTH);
		
		BCLogData log = BCLogDataServer.sharedLogServer().get(year,month,day);
		log.lock();
		for (Enumeration e = log.elements(); e.hasMoreElements(); ) {
			Hashtable bottle = (Hashtable)e.nextElement();
			
			if (mid.equals(bottle.get("mid"))) {
				// B
				bottle.put(type,Integer.toString(num));
				log.beDirty();
				break;
			}
		}
		log.unlock();
	}
    
    //private class ModifyCommand
    //{
		/*
			R}h			p[^
			Vote	[ω	(String)ΏۂMID,(Integer)[
			Agree	ӕ\ω	(String)ΏۂMID,(Integer)[
		*/
		/*String type;
		Object[] argv;
		
		public ModifyCommand(String type,Object[] argv)
		{
			this.type = type;
			this.argv = argv;
		}
		
		public String getType() {return type;}
		public Object[] getArgv() {return argv;}
	}
		
	private class FileWriteQueueElem
	{
		int year,month,day;
		BCLogData logdata;
		boolean compress;
		
		public FileWriteQueueElem(int year,int month,int day,BCLogData logdata,boolean compress)
		{
			this.year = year; this.month = month; this.day = day; this.logdata = logdata; this.compress = compress;
		}
		
		public int getYear() {return year;}
		public int getMonth() {return month;}
		public int getDay() {return day;}
		public BCLogData getLogData() {return logdata;}
		public boolean getCompress() {return compress;}
    }*/
}
