/*
	$Id: BCServerConnection.java,v 1.5 2003/02/11 06:43:48 admin Exp $
	-----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2002 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class BCServerConnection extends Thread
{
	protected static final boolean DEBUG = false;
	protected static void debugstr(String str) {
		if (DEBUG) System.out.println(str);
	}
	
    volatile boolean signal_stop = false;
    
    BCMainWindowController mainWindow;
    
    Socket s;
    InputStream is;
    OutputStream os;
    OutputStreamWriter osw;
    
    String luid;
    
    Vector chList;
    
    public BCServerConnection()
    {
        chList = new Vector();
        mainWindow = BCMainWindowController.sharedInstance();
    }
    
    public void run()
	{
		int pool = NSAutoreleasePool.push();
		
		try {
			_run();
		} catch (Exception e) {
			e.printStackTrace();
		}
		closeConnection();
		
		NSAutoreleasePool.pop(pool);
	}
	protected void _run() throws Exception
    {
		// ̊֐returnȂǂŔΐؒfAOŔΈُؒfB
		
        luid = getLUID(false);
        getChannels(); // `lXg擾
        
		boolean use_proxy = false;
		String bottleserver_host;
		int bottleserver_slppport;
        try
        {
			NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
			bottleserver_host = (String)defaults.objectForKey("bottleserver.servername");
			if (bottleserver_host == null) bottleserver_host = "bottle.mikage.to";
			bottleserver_slppport = defaults.integerForKey("bottleserver.slppport");
			if (bottleserver_slppport == 0) bottleserver_slppport = 9871;
			
			use_proxy = defaults.integerForKey("proxy.http.use") == 1;
			String http_proxy_host = (String)defaults.objectForKey("proxy.http.host");
			if (http_proxy_host == null || http_proxy_host.length() == 0) use_proxy = false;
			int http_proxy_port = defaults.integerForKey("proxy.http.port");
			if (defaults.objectForKey("proxy.http.port") == null) use_proxy = false;
			
			if (use_proxy) {
				s = new Socket(http_proxy_host,http_proxy_port);
			}
			else {
				s = new Socket(bottleserver_host,bottleserver_slppport);
			}
        }
        catch (Exception e)
        {
            // G[B̂B
            System.out.println("Connection failed.");
			e.printStackTrace();
            return;
        }
        
        // ڑł̂ŁAConnectedCWP[^onɂB
        mainWindow.setConnectedState(true);
        mainWindow.setChannelRegisteredCount(0);
        
		is = s.getInputStream();
		os = s.getOutputStream();
		
		// LUID𑗂ASLPP2.0ZbVJnB
		mainWindow.setSendState(true);
		writeStr(os,use_proxy ? "POST http://"+bottleserver_host+":"+bottleserver_slppport+"/ HTTP/1.0" : "POST / HTTP/1.0"); writeCRLF(os);
		writeStr(os,"Content-Length: "+luid.length()); writeCRLF(os);
		writeStr(os,"Content-Type: text/plain"); writeCRLF(os);
		writeCRLF(os);
		writeStr(os,luid); writeCRLF(os);
		mainWindow.setSendState(false);
		
		BufferedReader br = new BufferedReader(new InputStreamReader(is,"SJIS")); // b菈
		String line;
		
		// SLPPĨX|XB擪̃X|XȊO͖B
		// ̍s܂łǂ݌Ă΂B
		s.setSoTimeout(30 * 1000);
		
		mainWindow.setReceiveState(true);
		line = br.readLine();
		if (line == null) throw new Exception();
		if (line.indexOf("200 OK") == -1) {
			System.out.println("SLPP Server returned: "+line);
			return; // 200 OK܂܂ĂȂؒfBOB
		}
		
		while (true)
		{
			try
			{
				line = br.readLine();
				if (line == null) throw new Exception("");
				if (line.trim().length() == 0) break;
			}
			catch (InterruptedIOException e)
			{
				if (signal_stop) return;
			}
		}
		mainWindow.setReceiveState(false);
		
		// ȉAؒf܂ŉivɓǂݍ݃[vB
		String command;
		Vector params = new Vector();
		while (!signal_stop)
		{
			s.setSoTimeout(1 * 1000); // i1bsignal_stopB
			try
			{
				line = br.readLine();
				if (line == null) {
					throw new Exception(""); // T[o[łȂNȂ낤B
				}
				else {
					line = line.trim();
				}
				if (line.length() == 0) continue;
				
				// lineɒgB
				
				mainWindow.setReceiveState(true);
				s.setSoTimeout(30 * 1000); // f[^͏Ȃʂł܂Ƃ܂ė̂ŁA^CAEg͂ȂׂȂ悤ɂĂB
				
				// ̍s܂œǂݍ݂𑱂
				// SLPP1.1͒ǉf[^̗ނԂȂ悤Ȃ̂ŁÃf[^͂̂܂SSTPNGXgƂďĂ悢B
				command = line;
				while (true)
				{
					line = br.readLine();
					if (line == null) {
						throw new Exception("");
					}
					else {
						line = line.trim();
					}
					if (line.length() == 0) break; // ̍s炱̃NGXgIB
					
					params.add(line);
				}
				doCommand(command,params);
				params.clear();
				
				mainWindow.setReceiveState(false);
			}
			catch (InterruptedIOException e)
			{
				// ^CAEgB
				// ʂɏ͕KvȂB
			}
		}
    }
    
    private void closeConnection()
    {
        // I
        try
        {
            s.close();
        }
        catch (Exception e){}
		
		mainWindow.setConnectedState(false);
		mainWindow.setReceiveState(false);
		mainWindow.setSendState(false);
		mainWindow.setUsersCount(-1);
		mainWindow.setChannelsCount(-1);
		mainWindow.setChannelRegisteredCount(-1);
		
		// SLPPؒfĂ܂΂`lXg͍XVȂ̂ŖłB
		// āAXgB
		chList.clear();
		mainWindow.reloadChListView();
    }
    
    private void writeStr(OutputStream os,String param)
    {
        try{  os.write(param.getBytes(),0,param.length());  }catch(Exception e){}
    }
    
    private void writeCRLF(OutputStream os)
    {
        byte[] crlf = new byte[2];
        crlf[0] = 13;
        crlf[1] = 10;
        try{  os.write(crlf,0,2);  }catch(Exception e){}
    }
    
    private Hashtable slppSession(String param)
    {
        // SLPP2.0ZbVs܂B
        // bottle.mikage.to:80/bottle2.cgiƌM܂B
        // param̂܂POSTőM܂̂ŁA炩URLGR[hĂĉB
        // ȂAAgentwb_͂ŕt܂̂ŁA炩ߕtĂKv͂܂B
        Socket s = null;
        InputStream is;
        OutputStream os;
        Hashtable resp = null;
        
        String app_name = NSBundle.mainBundle().localizedStringForKey("CFBundleShortVersionString","SSTP Bottle Client for MacOS X","InfoPlist");
        param = "Agent%3A+"+URLEncoder.encode(app_name)+"%0D%0A" + param;
        
        try {
			NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
			String botservername = (String)defaults.objectForKey("bottleserver.servername");
			if (botservername == null) botservername = "bottle.mikage.to";
			int httpport = defaults.integerForKey("bottleserver.httpport");
			if (httpport == 0) httpport = 80;
						
			boolean use_proxy = defaults.integerForKey("proxy.http.use") == 1;
			String http_proxy_host = (String)defaults.objectForKey("proxy.http.host");
			if (http_proxy_host == null || http_proxy_host.length() == 0) use_proxy = false;
			int http_proxy_port = defaults.integerForKey("proxy.http.port");
			if (defaults.objectForKey("proxy.http.port") == null) use_proxy = false;
			
			if (use_proxy) {
				s = new Socket(http_proxy_host,http_proxy_port);
				resp = slppSession(s,botservername,httpport,app_name,param);
			}
			else {
				s = new Socket(botservername,httpport);
				resp = slppSession(s,app_name,param);
			}
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
		finally {
			try{
				s.close();
			}
			catch(Exception e) {}
			
			mainWindow.setReceiveState(false);
		}
	
		// Result:tB[hǂŁAG[烁bZ[W\B
		if (((String)resp.get("Result")).equals("Err"))
		{
			String message = (String)resp.get("ExtraMessage");
			if (message != null)
			{
				SCServerErrorWindowController errorwin = new SCServerErrorWindowController(message);
				errorwin.show();
			}
		}
        
        return resp;
    }
	
	protected Hashtable slppSession(Socket s,String user_agent,String param) throws Exception
	{
		return slppSession(s,null,0,user_agent,param);
	}
	protected Hashtable slppSession(Socket s,String bottleserver_host,int bottleserver_httpport,String user_agent,String param) throws Exception
	{
		// ̊֐߂s͎IcloseAReceiveCWP[^͏B
		// bottleserver_hostnullłȂ΁As̓vNVւ̐ڑƌ􂷁B
		Hashtable resp = new Hashtable();
		is = s.getInputStream();
		os = s.getOutputStream();
		s.setSoTimeout(40 * 1000);
		
		mainWindow.setSendState(true);
		writeStr(os,bottleserver_host != null ? "POST http://"+bottleserver_host+":"+bottleserver_httpport+"/bottle2.cgi HTTP/1.0" : "POST /bottle2.cgi HTTP/1.0"); writeCRLF(os);
		writeStr(os,"Host: bottle.mikage.to"); writeCRLF(os);
		writeStr(os,"User-Agent: "+user_agent); writeCRLF(os);
		writeStr(os,"Content-Type: application/x-www-form-urlencoded"); writeCRLF(os);
		writeStr(os,"Content-Length: " + param.length()); writeCRLF(os);
		writeCRLF(os);
		writeStr(os,param); writeCRLF(os);
		mainWindow.setSendState(false);
            
		BufferedReader br = new BufferedReader(new InputStreamReader(is,"SJIS")); // b菈
		String line;
            
		mainWindow.setReceiveState(true);
		// ܂̓T[o[X|X
		line = br.readLine();
		if (line == null || line.indexOf("200 OK") == -1) // X|X̂ǂɂ200 OKĂȂ
		{
			throw new Exception("Server returned "+line);
		}
            
		// s܂œǂݔ΂
		while (true)
		{
			line = br.readLine();			
			if (line == null) {
				throw new Exception();
			}
			else {
				line = line.trim();
			}
			if (line.length() == 0) break; // œǂݔ΂I
		}
            
		// f[^M
		while (true)
		{
			line = br.readLine();
			if (line == null) {
				break; // I
			}
			else {
				line = line.trim();
			}
			if (line.length() == 0) break; // I
			// Rŕ
			int colon_pos = line.indexOf(':');
			if (colon_pos == -1) throw new Exception("Server returned an invalid line: "+line);
			
			String type = line.substring(0,colon_pos).trim();
			String data = line.substring(colon_pos + 1).trim();
			resp.put(type,data);
		}
		return resp;
	}
    
    public String getLUID(boolean force_new)
    {
        // force_newfalsȅꍇAdefaultsLUIDǂݏoāAdefaultsɖVɎ擾ĕԂ܂B
        // force_newtruȅꍇAdefaulsƂ͖֌WɐVɎ擾ĕԂ܂B
        // defaultsɖĎ擾ɂsꍇnullԂ܂B
        String luid;
        NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
        
        if (!force_new)
        {
            luid = (String)defaults.objectForKey("luid");
            if (luid != null && luid.length() == 82) // LUIDĂ
            {
                return luid;
            }
        }
        
        Hashtable resp = slppSession("Command%3A+getNewId");
        String result = (String)resp.get("Result");
        if (result == null && !result.equals("OK"))
        {
            // 擾sBOB
            return null;
        }
        
        // defaultsɕۑ
        String newid = (String)resp.get("NewID");
        defaults.setObjectForKey(newid,"luid");
        defaults.synchronize();
        
        return newid;
    }
    
    public void getChannels()
    {
        // getChannels𑗐MāA`lXgXV܂B
        chList.clear();
        
        Hashtable resp = slppSession("Command%3A+getChannels");
        
        String result = (String)resp.get("Result");
        if (result == null && !result.equals("OK"))
        {
            // 擾sBOB
            mainWindow.reloadChListView();
            return;
        }
        
        int n_ch = 0;
        try{ n_ch = Integer.parseInt( (String)resp.get("Count") ); }catch(Exception e){}
        mainWindow.setChannelsCount(n_ch);
        
        for (int i = 1;i <= n_ch;i++)
        {
            String name = (String)resp.get("CH"+i+"_name");
            String info = (String)resp.get("CH"+i+"_info");
            int count = 0;
            try{  count = Integer.parseInt( (String)resp.get("CH"+i+"_count") );  }catch(Exception e){}
            String ghost = (String)resp.get("CH"+i+"_ghost");
            int np = 0;
            try{  np = Integer.parseInt( (String)resp.get("CH"+i+"_nopost") );  }catch(Exception e){}
            boolean nopost = (np == 1 ? true : false);
            
            chList.add(new BCChannelInfo(name,info,count,ghost,nopost));
        }
        
        mainWindow.reloadChListView();
    }
    
    public void loginChannels(Vector channels)
    {
        // ݓo^Ă`l̃XgchannelsǉAsetChannelsĂяo܂B
        if (channels.size() == 0) return;
        Vector new_array = new Vector(channels);
        
        int n_ch = chList.size();
        for (int i = 0;i < n_ch;i++)
        {
            BCChannelInfo info = (BCChannelInfo)chList.elementAt(i);
            if (info.registered())
            {
                // new_arrayāAɃGgĂ疳B
                boolean found = false;
                int n_newarray = new_array.size();
                for (int j = 0;j < n_newarray;j++)
                {
                    if (((String)new_array.elementAt(j)).equals(info.name()))
                    {
                        found = true;
                        break;
                    }
                }
                if (!found)
                {
                    new_array.add(info.name());
                }
            }
        }
        
        setChannels(new_array);
    }
    
    public void logoutChannels(Vector channels)
    {
        // ݓo^Ă`l̃XgchannelsAsetChannelsĂяo܂B
        if (channels.size() == 0) return;
        Vector new_array = new Vector();
        
        int n_ch = chList.size();
        for (int i = 0;i< n_ch;i++)
        {
            BCChannelInfo info = (BCChannelInfo)chList.elementAt(i);
            if (!info.registered()) continue; // o^ς݂łȂΗp͂ȂB
            
            int n_ch_to_logout = channels.size();
            boolean found = false;
            for (int j = 0;j < n_ch_to_logout;j++)
            {
                if (info.name().equals( (String)channels.elementAt(j) ))
                {
                    found = true;
                    break;
                }
            }
            if (found)
            {
                info.setRegistered(false);
            }
            else
            {
                new_array.add(info.name());
            }
        }
        
        setChannels(new_array);
    }
    
    public void setChannels(Vector channels)
    {
        // SLPP2.0CGIsetChannels𑗂܂B
        // channels̓`l̔złB
        if (!isAlive()) return;
        
        StringBuffer command = new StringBuffer();
        command.append("Command%3A+setChannels%0D%0A");
        command.append("LUID%3A+"+URLEncoder.encode(luid)+"%0D%0A");
        
        int n_ch_to_register = channels.size();
        for (int i = 0;i < n_ch_to_register;i++)
        {
            String chname = null;
            try{chname = new String( ((String)channels.elementAt(i)).getBytes("SJIS") );}catch(Exception e){}
            command.append("Ch"+(i+1)+"%3A+"+URLEncoder.encode(chname)+"%0D%0A");
        }
        
        // commandB
        
        Hashtable resp = slppSession(command.toString());
        // uResult: OKvȂ`lXgregisteredtB[hXVB
        if (((String)resp.get("Result")).equals("OK"))
        {
            int n_ch = chList.size();
            for (int i = 0;i < n_ch;i++)
            {
                BCChannelInfo info = (BCChannelInfo)chList.elementAt(i);
                String itsName = info.name();
                
                // itsNamechannels̒Ɋ܂܂Ă邩ǂ𒲂ׂB
                boolean found = false;
                for (int j = 0;j < n_ch_to_register;j++)
                {
                    if ( itsName.equals( (String)channels.elementAt(j) ) )
                    {
                        found = true;
                        break;
                    }
                }
                info.setRegistered(found);
            }
            mainWindow.reloadChListView();
        }
    }
    
    public void doCommand(String command,Vector params)
    {
        /*System.out.println(command);
        int n_params = params.count();
        for (int i = 0;i < n_params;i++)
        {
            System.out.println( (String)params.objectAtIndex(i) );
        }
        System.out.println("");*/
        
        // SLPP2.0T[o[瑗Ă郁bZ[W߂ĎsB
        if (command.equals("allUsers"))
        {
            docommand_allUsers(params);
        }
        else if (command.equals("channelUsers"))
        {
            docommand_channelUsers(params);
        }
        else if (command.equals("channelList"))
        {
            docommand_channelList(params);
        }
        else if (command.equals("broadcastMessage"))
        {
            docommand_broadcastMessage(params);
        }
        else if (command.equals("unicastMessage"))
        {
            docommand_unicastMessage(params);
        }
        else if (command.equals("forceBroadcastMessage"))
        {
            docommand_forceBroadcastMessage(params);
        }
		else if (command.equals("forceBroadcastInformation"))
		{
			docommand_forceBroadcastInformation(params);
		}
		else if (command.equals("closeChannel"))
		{
			docommand_closeChannel(params);
		}
    }
    
    public void docommand_allUsers(Vector params)
    {
        // p[^́AuNum: [n_users]v̈ŝ݁B
        int n_users = 0;
        String param = (String)params.elementAt(0);
        try{  n_users = Integer.parseInt( param.substring(4).trim() );  }catch(Exception e){}
        
        mainWindow.setUsersCount(n_users);
    }
    
    public void docommand_channelUsers(Vector params)
    {
        String name = null;
        int newcount = 0;
        
        int n_params = params.size();
        for (int i = 0;i < n_params;i++)
        {
            String line = (String)params.elementAt(i);
            
            if (line.startsWith("Channel:"))
            {
                name = line.substring(8).trim();
            }
            else if (line.startsWith("Num:"))
            {
                try{ newcount = Integer.parseInt(line.substring(4).trim()); }catch(Exception e){}
            }
        }
        
        BCChannelInfo info = findChInfoNamed(name);
        if (info != null)
        {
            info.setCount(newcount);
            mainWindow.reloadChListView();
        }
    }
    
    public void docommand_channelList(Vector params)
    {
        // Ƃ肠Num:ʂɕ\āAEntry:̍ŌɂĂJEgXV邾łB
        int n_params = params.size();
        for (int i = 0;i < n_params;i++)
        {
            String line = (String)params.elementAt(i);
            
            if (line.startsWith("Entry:"))
            {
                String name = line.substring(6, line.lastIndexOf(' ') ).trim();
                String countdata = line.substring( line.lastIndexOf('(')+1 , line.lastIndexOf(')') ).trim();
                int newcount = 0;
                try{ newcount = Integer.parseInt(countdata); }catch(Exception e){}
                
                BCChannelInfo info = findChInfoNamed(name);
                if (info != null)
                {
                    info.setCount(newcount);
                }
            }
            else if (line.startsWith("Num:"))
            {
                int n_regd_ch = 0;
                try{ n_regd_ch = Integer.parseInt(line.substring(4).trim()); }catch(Exception e){}
                
                mainWindow.setChannelRegisteredCount(n_regd_ch);
            }
        }
        mainWindow.reloadChListView();
    }
    
    public void docommand_broadcastMessage(Vector param)
    {
        String mid = null,channel = null,uid = null,script = null,ifghost = null;
        
        int n_params = param.size();
        for (int i = 0;i < n_params;i++)
        {
            String line = (String)param.elementAt(i);
            if (line.startsWith("MID:"))
            {
                mid = line.substring(4).trim();
            }
            else if (line.startsWith("Channel:"))
            {
                channel = line.substring(8).trim();
            }
            else if (line.startsWith("SenderUID:"))
            {
                uid = line.substring(10).trim();
            }
			else if (line.startsWith("Script:"))
			{
				script = line.substring(7).trim();
			}
			else if (line.startsWith("IfGhost:"))
			{
				ifghost = line.substring(8).trim();
			}
		}
		
		String ghost_destination,ghost_default;
		// w肳ꂽ`lTAS[Xg擾B
		BCChannelInfo ci = findChInfoNamed(channel);
		if (ci == null) // fatal error
		{
			System.err.println("BCServerConnection : fatal error. couldn't get ghost name of channel "+channel);
		}
		ghost_default = ci.ghost();
		ghost_destination = (ifghost == null ? ghost_default : ifghost); // IIfGhostw肳Ă炻ׂȂB
		
		// /tmp/botcli-received-bottleΏށB
		File fifo = new File("/tmp/botcli-received-bottle");
		if (fifo.exists()) {
			try {
				BufferedWriter bw = new BufferedWriter(
					new OutputStreamWriter(
						new FileOutputStream(fifo),"UTF-8"));
				bw.write("Charset: UTF-8\n");
				bw.write("IfGhost: "+ghost_destination+"\n");
				bw.write("Script: "+script+"\n");
				bw.close();
			}
			catch (Exception e) {}
		}
		
		String app_name = NSBundle.mainBundle().localizedStringForKey("CFBundleShortVersionString","BotCli","InfoPlist");
		Vector sstp_req = new Vector();
		sstp_req.add("SEND SSTP/1.4");
		sstp_req.add("Sender: SSTP Bottle ["+channel+(ifghost == null ? "]" : "][Target:"+ifghost+"]"));
		sstp_req.add("IfGhost: "+ghost_destination);
		sstp_req.add("Script: "+BCScriptAnalyzer.expandYenURL(script));
			
		BCFoundation.sharedFoundation().playSoundOfReceiveBottle();
        BCFoundation.sharedFoundation().getQueue().push(sstp_req);
        
        BCLogDataServer.sharedLogServer().broadcastLog(script,channel,mid,uid,ghost_default,ifghost);
    }
    
    public void docommand_unicastMessage(Vector param)
    {
        String uid = null,script = null;
        
        int n_params = param.size();
        for (int i = 0;i < n_params;i++)
        {
            String line = (String)param.elementAt(i);
            if (line.startsWith("SenderUID:"))
            {
                uid = line.substring(10).trim();
            }
            else if (line.startsWith("Script:"))
			{
				script = line.substring(7).trim();
            }
        }
	
		Vector sstp_req = new Vector();
		sstp_req.add("SEND SSTP/1.1");
		sstp_req.add("Sender: SSTP Bottle - unicasted message -");
		sstp_req.add("Script: "+BCScriptAnalyzer.expandYenURL(script));
			
		BCFoundation.sharedFoundation().playSoundOfReceiveBottle();
        BCFoundation.sharedFoundation().getQueue().push(sstp_req);
        
        BCLogDataServer.sharedLogServer().unicastLog(script,uid);
    }
    
    public void docommand_forceBroadcastMessage(Vector param)
    {
		String mid = null,uid = null,msg = null,script = null;
		Vector sstp_req = null;
	
        int n_params = param.size();
        for (int i = 0;i < n_params;i++)
        {
            String line = (String)param.elementAt(i);
			if (line.startsWith("MID:"))
            {
                mid = line.substring(4).trim();
            }
            else if (line.startsWith("SenderUID:"))
            {
                uid = line.substring(10).trim();
            }
			else if (line.startsWith("DialogMessage:"))
            {
                msg = line.substring(14).trim();
            }
            else if (line.startsWith("Script:"))
			{
				script = line.substring(7).trim();
			}
		}
	
		if (script != null)
		{
			sstp_req = new Vector();
			sstp_req.add("SEND SSTP/1.1");
			sstp_req.add("Sender: SSTP Bottle - Message From Admin -");
			sstp_req.add("Script: "+BCScriptAnalyzer.expandYenURL(script));
		}
	
		BCFoundation.sharedFoundation().playSoundOfReceiveBottle();
	
		if (msg != null) // DialogMessage
		{
			SCAdminMessageWindowController msgwin = new SCAdminMessageWindowController(msg);
			msgwin.show();
		}
		
		if (sstp_req != null) // SSTPNGXg
		{
			BCFoundation.sharedFoundation().getQueue().push(sstp_req);
		}
        
        BCLogDataServer.sharedLogServer().forceBroadcastLog(script,mid,uid,msg);
    }
    
    public void docommand_forceBroadcastInformation(Vector param)
    {
		String type = null,mid = null,num = null;
		
		int n_params = param.size();
        for (int i = 0;i < n_params;i++)
        {
            String line = (String)param.elementAt(i);
			if (line.startsWith("Type:"))
            {
                type = line.substring(5).trim();
            }
			else if (line.startsWith("MID:"))
            {
                mid = line.substring(4).trim();
            }
			else if (line.startsWith("Num:"))
            {
                num = line.substring(4).trim();
            }
        }
	
		try
		{
			if (type.equals("Vote"))
			{
				BCLogModifier.updateVoteNumOfBottle(mid,Integer.parseInt(num));
				//BCFoundation.sharedFoundation().getLogModifier().updateVoteNumOfBottle(mid,Integer.parseInt(num));
			}
			else if (type.equals("Agree"))
			{
				BCLogModifier.updateAgreeNumOfBottle(mid,Integer.parseInt(num));
				//BCFoundation.sharedFoundation().getLogModifier().updateAgreeNumOfBottle(mid,Integer.parseInt(num));
			}
		}
		catch (Exception e) {}
    }
    
    public void docommand_closeChannel(Vector param)
    {
		// ͂Ƃɂ悤B
		// ߂ǂB
		
		/*
		String ch_name;
	
		int n_params = param.size();
		for (int i = 0;i < n_params;i++)
		{
			String line = (String)param.objectAtIndex(i);
			if (line.startsWith("Channel: "))
			{
			
			}
		}
		*/
    }
    
    public BCChannelInfo findChInfoNamed(String name)
    {
        // Onameł`lBCChannelInfoԂ܂B
        // ȂnullɂȂ܂B
        if (name == null) return null;
        BCChannelInfo result = null;
        
        int n_ch = chList.size();
        for (int i = 0;i < n_ch;i++)
        {
            BCChannelInfo info = (BCChannelInfo)chList.elementAt(i);
            if (info.name().equals(name))
            {
                result = info;
                break;
            }
        }
        
        return result;
    }
    
    public void broadcast(String script,String chname,String ghost)
    {
        // sendBroadcast|Xg܂B
        // script: GR[hÕXNvg
        // chname: `l
		// ghost: IfGhostwinullȂȗj
        StringBuffer command = new StringBuffer();
        try
        {
            command.append("Command%3A+sendBroadcast%0D%0A");
            command.append("Channel%3A+"+URLEncoder.encode(new String(chname.getBytes("SJIS")))+"%0D%0A");
            command.append("LUID%3A+"+URLEncoder.encode(luid)+"%0D%0A");
            command.append("Talk%3A+"+URLEncoder.encode(new String(script.getBytes("SJIS")))+"%0D%0A");
			if (ghost != null) command.append("Ghost%3A+"+URLEncoder.encode(new String(ghost.getBytes("SJIS")))+"%0D%0A");
        }
        catch (Exception e) {}
        // R}h
        
        slppSession(command.toString());
        
        // ̖O`lTAS[Xg擾B
        BCChannelInfo ci = findChInfoNamed(chname);
        String ifghost = (ci == null ? null : ci.ghost());
        
        BCLogDataServer.sharedLogServer().sendBroadcastLog(script,chname,ifghost,ghost);
    }
    
    public void vote(String mid,String voteType)
    {
		// voteMessage|Xg܂B
		// voteTypeɂ͕"Vote""Agree"nĉB
		StringBuffer command = new StringBuffer();
		command.append("Command%3A+voteMessage%0D%0A");
		command.append("LUID%3A+"+URLEncoder.encode(luid)+"%0D%0A");
		command.append("MID%3A+"+URLEncoder.encode(mid)+"%0D%0A");
		command.append("VoteType%3A+"+voteType+"%0D%0A");
		
		slppSession(command.toString());
    }
    
    public Vector getChannelList()
    {
        return chList;
    }
    
    public void terminate()
    {
        signal_stop = true;
        while (isAlive()) {}
    }
}
